#!/usr/bin/perl

#!perl



use strict;
$| = 1;

use settings;

my $filename = settings->filename;
&create_bases;

my $HEADER_SENT;
my %FORM_DATA;
&cgi_input ;

&subscribe;


# ----------------------------------------------------------------------
sub cgi_input  {

#
# get CGI values (simply method)
#

my $whichmethod = $ENV{'REQUEST_METHOD'};

my $forminfo;

if($whichmethod eq 'GET'){ 
    $forminfo = $ENV{'QUERY_STRING'};
  }else{
    $forminfo = <STDIN>; 
  } 

my @key_value_pairs = split(/&/,$forminfo); 
foreach my $pair (@key_value_pairs){

    my ($key,$value) = split(/=/,$pair);
     $value =~ s/\+/ /g; 
     $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
     $value =~ s/'/\\'/g;
     $FORM_DATA{$key} = $value;
  }
} 
# ----------------------------------------------------------------------
sub subscribe {

my $email = $FORM_DATA{'email'};
my $pcode = $FORM_DATA{'pcode'};
my $name = $FORM_DATA{'name'};

open(OUT, ">>$filename") || &print_response("cant open file, $!"); 
print OUT $pcode . '|' . $name. '|' . $email . "\n" ;  #subscribe
close(OUT);

my $redirect = $FORM_DATA{'redirect'};

&print_redirection($redirect);

}

# ----------------------------------------------------------------------
sub create_bases {
  unless ( -e $filename )  { &create_file($filename) };
}
# ----------------------------------------------------------------------

sub create_file {

  my($fname) = @_;

  open(OUT, ">$fname") || &print_response("cant open file, $!"); 
  close(OUT);
}

# ----------------------------------------------------------------------

sub print_redirection {
#
# redirects the browser to the desired URL, if possible
#
    my( $location ) = @_;

    print qq|Location: $location\n\n|;
    $HEADER_SENT = 'yes';

    return undef;
}

# ----------------------------------------------------------------------
