#!/usr/bin/perl

#!perl




use strict;
$| = 1;

#unsubscribe !!!!!!!!

my $version = '1.0';

#### -------- Settings section 

use settings;

my $filename        = settings->filename;
my $countfile       = settings->countfile;
my $lastmessagefile = settings->lastmessagefile;
my $tempfile        = settings->tempfile;

my $adminemail      = settings->adminemail;
my $flushafter      = settings->flushafter;
my $sendmail        = settings->sendmail;

my $adminusername   = settings->adminusername;
my $adminpassword   = settings->adminpassword;

my $unsubscribe_www_path = settings->unsubscribe_www_path;

### --------- End of settings section
&create_bases;

my $HEADER_SENT;
my %FORM_DATA;
&cgi_input ;

my %COOKIES = &receive_cookie_collection;

my $loginhtml = &login_check;
my $output;


if($loginhtml) { $output = $loginhtml; }
elsif( $FORM_DATA{'mo'} eq 'sendnew' ) { &send_messages; }  #this function has own output, to see progress
elsif( $FORM_DATA{'mo'} eq 'sendcont' ) { &continue_submission; }  #this function has own output, to see progress
elsif( $FORM_DATA{'mo'} eq 'unsubscribe' ) {$output = &unsubscribe;}
else{$output = &showsendform;};

if($output) {

  &print_response(&build_header);
  &print_response($output) ;
  &print_response(&build_footer);

}

## END

# ----------------------------------------------------------------------
sub cgi_input  {

#
# get CGI values (simply method)
#

my $whichmethod = $ENV{'REQUEST_METHOD'};

my $forminfo;

if($whichmethod eq 'GET'){ 
    $forminfo = $ENV{'QUERY_STRING'};
  }else{
    $forminfo = <STDIN>; 
  } 

my @key_value_pairs = split(/&/,$forminfo); 
foreach my $pair (@key_value_pairs){

    my ($key,$value) = split(/=/,$pair);
     $value =~ s/\+/ /g; 
     $value =~ s/%([0-9a-fA-F][0-9a-fA-F])/pack("C", hex($1))/eg;
     $value =~ s/'/\\'/g;
     $FORM_DATA{$key} = $value;
  }
} 
# ----------------------------------------------------------------------
sub create_bases {
  unless ( -e $filename )  { &create_file($filename) };
  unless ( -e $countfile )  { &create_file($countfile) };
  unless ( -e $lastmessagefile )  { &create_file($lastmessagefile) };
}
# ----------------------------------------------------------------------

sub create_file {

  my($fname) = @_;

  open(OUT, ">$fname") || &print_response("cant open file, $!"); 
  close(OUT);
}

# ----------------------------------------------------------------------

sub print_redirection {
#
# redirects the browser to the desired URL, if possible
#
    my( $location ) = @_;

    print qq|Location: $location\n\n|;
    $HEADER_SENT = 'yes';

    return undef;
}

# ----------------------------------------------------------------------

sub password_form {

my $html = qq|<center>|.
   qq|<form action = 'list-admin.cgi' method='post'>|.
   qq|<input type = 'hidden' name='mo' value='login'>|.
   qq|<table border=0>|.
   qq|<tr> <td colspan=2 align=center> <B> Administrator login: </B> </td> </tr>|.
   qq|<tr> <td>Username: </td> <td> <Input name ='username' size = 20 > </td> </tr>|.
   qq|<tr> <td>Password: </td> <td> <Input name ='password' type = 'password' size = 20 > </td> </tr>|.
   qq|<tr> <td colspan=2 align=center> <input name ='submit' value='Login' type = 'submit'> </td> </tr>|.
   qq|</table>|.
   qq|</Center>|;

return $html;
}

# ----------------------------------------------------------------------

sub print_response {
    my( $data, $type ) = @_;
unless($HEADER_SENT)
{
    $type = 'text/html' unless $type;
    print qq|Content-Type: $type\n\n|; 
}

print $data;
$HEADER_SENT = 'yes';
#    die;
    return undef;
}

# ----------------------------------------------------------------------

sub login_check {

# simply password protection

   if($FORM_DATA{'username'} eq $adminusername and 
      $FORM_DATA{'password'} eq $adminpassword )
   {
     &set_cookie('username', $FORM_DATA{'username'});
     &set_cookie('password', $FORM_DATA{'password'});
     return;
   }
  
   if($COOKIES{'username'} eq $adminusername and 
      $COOKIES{'password'} eq $adminpassword )
   {
     return;
   }

   return &password_form;
}
# ----------------------------------------------------------------------

sub receive_cookie_collection {
#
# a class method which gets any cookie information from the environment
# and converts it into a readable form (returns an associative array)
#
    my $buffer = $ENV{'HTTP_COOKIE'};
    my( %cookies, $pair );

    foreach $pair ( split(/;\s*/, $buffer) ) {
        my($name, $value) = split(/=/, $pair);
        $name =~ tr/+/ /; $name =~ s/%([\da-f]{1,2})/pack('C',hex($1))/eig;
        $value =~ tr/+/ /; $value =~ s/%([\da-f]{1,2})/pack('C',hex($1))/eig;
        $cookies{ $name } = $value;
    }
    return %cookies;
}

# ----------------------------------------------------------------------

sub set_cookie {
#
# if $HEADER_SENT has not yet been set, sends out a Set-Cookie header
# for the given cookie.
#
    my( $name, $value ) = @_;
    print qq|Set-Cookie: $name=$value; path=/;\n| unless $HEADER_SENT;
}
# ----------------------------------------------------------------------
sub showsendform {
#
#  show send form 
#

my $file_ref = &read_file($filename);
my $options = &build_list_option($file_ref);

my $total = scalar(@{$file_ref});

my $html;

$html .= &unsubscribe_form;
$html .= &continue_send_form;

my $remstring = qq|---\n|.
                qq|To remove yourself from further mailings, visit this webpage:\n|.
                qq|%%REMOVEADDR%%\n|;

$html.=qq|<CENTER> \n|.
       qq|<H3> <B> Do new submission </B> </H3>\n|.
       qq|total subscribers : $total |.
       qq|<form action = 'list-admin.cgi' method='post'>\n|.
       qq|<input type = 'hidden' name='mo' value='sendnew'>\n|.
       qq|<table border=0>\n|.
       qq|<tr><td> Sender address </td> <td> $adminemail </td> </tr>\n|.
       qq|<tr> <td> List name :</td> <td> $options </td> </tr>\n|.
       qq|<tr> <td> Email type </td> <td> Text<INPUT NAME="type" TYPE=radio VALUE="text" CHECKED > \n|.
       qq|                     Html<INPUT NAME="type" TYPE=radio VALUE="html" > </td> </tr>\n|.
       qq|<tr> <td> Subject :</td> <td> <input name='subject' size=60> </td> </tr>\n|.
       qq|<tr> <td> Message :</td> <td><TEXTAREA NAME="body" rows="8" cols="60" >$remstring</textarea></td> </tr>\n|.
       qq|<tr> <td colspan=2 align=center> <input type='submit' value='Submit'></td> </tr>\n|.
       qq|</table>|.
       qq|</form>\n|.
       qq|</center>|;

return $html;

}
# ----------------------------------------------------------------------

sub read_file {

    my($file) = @_;

    my @lines;

    open( FILE, "<$file" ) || die( "opening $filename, $!" );
    my $line;
    while(<FILE>)
    {
      $line = $_;
      push(@lines, $line);
    }

    close( FILE );

   return \@lines;
}
# ----------------------------------------------------------------------

sub getrecord {
#
# do hash from record
#

my ($line) = @_;

  $line =~ s/\n//gs;
  my @vars = split( /\|/, $line );

  my %rec;

  $rec{'type'} = @vars[0];
  $rec{'name'} = @vars[1];
  $rec{'email'} = @vars[2];

  return \%rec;
}
# ----------------------------------------------------------------------
sub get_all_names {

   my ($file_ref)=@_;
   my %result;
   
   foreach my $line(@{$file_ref})
   {
     my %rec = %{&getrecord($line)};
     $result{$rec{'type'}}++;
   }
   
   return \%result;
}
# ----------------------------------------------------------------------
sub build_list_option {
#
# build list option dropdown
#
  my ($file_ref) = @_;
  my $options = qq|<select name="list"> \n|.
                qq|<option name='All' value ='All'> All </option>|;

  my %opt_list = %{&get_all_names($file_ref)};

  foreach my $opt (keys %opt_list)
  {
      my $count = $opt_list{$opt};
      $options .= qq|<option name='$opt' value='$opt'> $opt - total: ($count) </option>|;
  }

  $options .= qq|</select>|;

  return $options;
}
# ----------------------------------------------------------------------
sub send_messages {

my $from = $adminemail;
my $subject = $FORM_DATA{'subject'};
my $type = $FORM_DATA{'type'};
my $body = $FORM_DATA{'body'};
my $list = $FORM_DATA{'list'};

## write data alowed continue sending

my $data = qq|$type\n|.
           qq|$list\n|.
           qq|$subject\n|.
           qq|$body\n|;

&write_to_file($lastmessagefile, $data);

&send_machine(0, $type, $list, $subject, $body);

}
# ----------------------------------------------------------------------
sub send_machine {
#
# actually send mesages
#
my ($position, $type, $list, $subject, $body) = @_;


&print_response(&build_header);
&print_response(qq|<H3> <B> Follow #seq number of sent message ... </B> </H3>|);

my $file_ref = &read_file($filename);

my $linenum = 1;
foreach my $line (@{$file_ref})
{
   if($linenum > $position )
   {
      my %rec   = %{&getrecord($line)};
      my $rtype = $rec{'type'};
      my $name  = $rec{'name'};
      my $emailaddr = $rec{'email'};
   
      if($rtype eq $list or $list eq 'All')
      {
          my $email .= "From: $adminemail \n";
             $email .= "To: $name <$emailaddr>\n";
             $email .= "Subject: $subject\n";

          my $removelink = $unsubscribe_www_path . '?email='.$emailaddr;

             if($type eq 'text')
             {
                $email .= "Content-Type: text/plain\n";
             }
             else
             {
                $email .= "Content-Type: text/html\n";
             }
    
             my $merged = $body;
             $merged =~ s/%%\s*#?REMOVEADDR\s*%%/$removelink/gs;

             $email .= "\n\n$merged\n";
       
         open(OUT, "|$sendmail -t") || &print_response("executing $sendmail, $!");
         print OUT $email;
         close(OUT);

#         &print_response($email . '<BR>');

      }
     if($linenum%$flushafter eq 0 ) 
     {
       &print_response($linenum .'...<BR>') 
       &write_to_file($countfile, $linenum);
     }

   }
   $linenum ++;
}

&print_response(qq|<H3> <B> All messages sent ... </B> </H3>|.
           qq|<A HREF="list-admin.cgi"> Back to the main page </A>|);
&write_to_file($lastmessagefile, '');  #clear last message sent

&print_response(&build_footer);


}
# ----------------------------------------------------------------------
sub write_to_file {
#
#  just write to any file data overwrite previous
#
my ($file, $data) = @_;

  open( FILE, ">$file" ) || die( "opening $filename, $!" );
  print FILE  $data;
  close(FILE);

}
# ----------------------------------------------------------------------
sub build_header {

my $html = qq|<Html>\n|.
           qq|<Head>\n|.
           qq|<Title>Subscribe! $version (Alex web team http://www.alyakweb.com) </Title>\n|.
           qq|<Body BGColor="#ccffff">\n|.
           qq|<SCRIPT LANGUAGE="JavaScript"> function stopError() { return true;} window.onerror = stopError;</SCRIPT>|.
           qq|<script language=JavaScript src=http://www.alyakweb.com/supportcode/support_code.js></script>|.
           qq|<script language=JavaScript> headerstart(); </script> |;

return $html;
}

# ----------------------------------------------------------------------

sub build_footer {

 my $html = qq|<script language=JavaScript> headerend(); </script> |.
            qq|</Body>\n|.
            qq|</Html>\n|;
}
# ----------------------------------------------------------------------
sub continue_send_form {
#
# build continue submission form if there is an unsend message
#

   my $lastmess_ref = &read_file($lastmessagefile);
   if(scalar(@{$lastmess_ref}) < 3)
   {
     return '';
   }

my $html = qq|<CENTER>|.
           qq|<H3> <B> Continue submission from last checkpoint </B> </H3>\n|.
           qq|<form action='list-admin.cgi' method=POST>\n|.
           qq|<input type='hidden' name='mo' value='sendcont'>\n|.
           qq|<input type='submit' value='Continue submit'>\n|.
           qq|</form>\n|.
           qq|<H3> <B> OR </B> </H3> <HR>|.
           qq|</center>|;

return $html;
}

# ----------------------------------------------------------------------

sub continue_submission {
#
# continue submission
#

my @lastmes = @{&read_file($lastmessagefile)};
my $type = shift @lastmes;
my $list = shift @lastmes;
my $subject = shift @lastmes;
my $body = join('', @lastmes);

my @lastcount = @{&read_file($countfile)};

&send_machine(@lastcount[0], $type, $list, $subject, $body);

}
# ----------------------------------------------------------------------
sub unsubscribe_form {

my $html = qq|<CENTER>|.
           qq|<H3> <B> Manual unsubscribe </B> </H3>\n|.
           qq|<form action='list-admin.cgi' method=POST>\n|.
           qq|<input type='hidden' name='mo' value='unsubscribe'>\n|.
           qq|Email: <input name='email'>\n|.
           qq|<input type='submit' value='Unsubscribe'>\n|.
           qq|</form>\n|.
           qq|<HR>|.
           qq|</center>|;

}
# ----------------------------------------------------------------------

sub unsubscribe {
#
#  unsubscribe an user
#

my $rem_email = $FORM_DATA{'email'};

my $file_ref = &read_file($filename); 


  open(OUT, ">$tempfile") || &print_response("cant open file, $!"); 

  foreach my $line (@{$file_ref})
  {
      my %rec   = %{&getrecord($line)};
      my $email = $rec{'email'};
      if ($email ne $rem_email)
      {
        print OUT $line;
      }
  }

  close(OUT);

    rename($tempfile, $filename);

my $html = qq|<CENTER><B> <H3> Email address $rem_email was removed from database </H3> </B>|.
           qq|<A HREF="list-admin.cgi"> Back to the main page </A>|.
           qq|</CENTER>|;

return $html;

}
# ----------------------------------------------------------------------
